<?php

if (!defined('ABSPATH'))
  exit; // Exit if accessed directly

if (!class_exists('WC_Efactura_Aceptacion')) :


  if (!class_exists('WP_List_Table')) {
    require_once(ABSPATH . 'wp-admin/includes/class-wp-list-table.php');
  }

  class WC_Efactura_Aceptacion extends WP_List_Table {

    public $template;
    
    function __construct() {
      global $status, $page;

      parent::__construct(array(
        'singular' => 'xml',
        'plural' => 'xmls',
      ));
    }

    function column_emisor($item){
      $actions = array(
        'delete' => sprintf('<a href="?page=%s&action=delete&clave=%s">%s</a>', 'wc-settings&tab=settings_tab_efactura&section=accept_interface', $item['clave'], __('Eliminar')),
      );

      return sprintf('%s %s', $item['emisor'], $this->row_actions($actions));
    }
      
    function column_default($item, $column_name) {
      return $item[$column_name];
    }

    function column_cb($item) {
      return sprintf(
          '<input type="checkbox" name="clave[]" value="%s" />', $item['clave']
      );
    }
    
    function column_hacienda_respuesta($item) {
      if ($item['hacienda_respuesta'] == 'ACEPTADA') {
        return sprintf(
            '<a href="%s" download="factura-aceptada.xml">XML ACEPTADO</a>', get_site_url() . '/' . str_replace(ABSPATH, '', ACCEPTED_PATH . "Aceptacion-{$item['clave']}.xml")
        );
      }
      if ($item['hacienda_respuesta'] == 'Rechazado-parcial') {
        return sprintf(
            '<a href="%s" download="factura-rechazada.xml">XML DE RECHAZO</a>', get_site_url() . '/' . str_replace(ABSPATH, '', ACCEPTED_PATH . "Rechazo-{$item['clave']}.xml")
        );
      }
      ?>
        <div id="row-message-action-container-<?php echo $item['clave']?>">
          <div id="fe-options-block">
                <p id="fe-message-status"><strong><?php echo $item['hacienda_respuesta'] ?></strong></p>
                <div id="firmar-options-block" style="<?php echo ($item['hacienda_respuesta'] == 'SIN FIRMAR') ? '' : 'display: none' ?>">          
                    <a href= "#" id="ms-feconfirm" class="button-primary bt-ms-action" action="Firmar" clave="<?php echo $item['clave'] ?>"><?php echo __('Firmar') ?></a>      
                    <a href= "#" id="fe-message-delete" class="button-secondary bt-ms-action" action="Eliminar" clave="<?php echo $item['clave'] ?>"><?php echo __('Eliminar') ?></a>          
                </div>

                <div id="message-options-block" style="<?php echo ($item['hacienda_respuesta'] == 'SIN FIRMAR') ? 'display: none' : '' ?>">          
                    <a href= "#" id="ms-feconfirm" class="button-primary bt-ms-action" action="Confirmar" clave="<?php echo $item['clave'] ?>"><?php echo __('Confirmar') ?></a>
                    <a href= "#" id="ms-fedeny" class="button-secondary bt-ms-action" action="Rechazar" clave="<?php echo $item['clave'] ?>"><?php echo __('Rechazar') ?></a><hr>
                    <a href= "#" id="ms-fedeny-partial" class="button-secondary bt-ms-action" action="Rechazado-parcial" clave="<?php echo $item['clave'] ?>"><?php echo __('Rechazar Parcialmente ') ?></a>
                </div>
                <input type="hidden" value="" id="action-holder">      
            </div>
            <span class="waiting spinner"></span>

            <div id="message-confirmation-block" style="display: none">
                <p id="fe-question-message"></p>
                <a href= "#" class="button-primary fe-message-confirm" clave="<?php echo $item['clave'] ?>"><?php echo __('Si') ?></a>
                <a href= "#" class="button-secondary fe-message-deny" clave="<?php echo $item['clave'] ?>" style="background-color: #c50505; color: white"><?php echo __('No') ?></a>
                <span class="waiting spinner"></span>
                <span id="message-confirmation-block-message"></span>
            </div>
        </div> 
          <?php
            }

    function column_file_name($item) {
      return sprintf(
          '<a href="%s" download>Download</a>', get_site_url() . '/' . str_replace(ABSPATH, '', ACCEPTED_PATH . $item['file_name'])
      );
    }

    function get_columns() {

      $columns = array(
        //'cb' => '<input type="checkbox" />', TODO: SOLUCIONAR BULK OPERATION
        'emisor' => __('Emisor'),
        'receptor' => __('Receptor'),
        'fecha' => __('Fecha'),
        'file_name' => __('Archivo XML'),
        'hacienda_respuesta' => __('Estado'),
      );
      return $columns;
    }

    function get_sortable_columns() {
      $sortable_columns = array(
        'emisor' => array('emisor', true),
        'receptor' => array('receptor', false),
        'hacienda_respuesta' => array('hacienda_respuesta', false),
      );
      return $sortable_columns;
    }

    function get_bulk_actions() {
      //TODO: FIX BULKS FOR ERROR LINK EXPIRED 
//      $actions = array(
//        'delete' => 'Delete'
//      );
//      return $actions;
    }

    function process_bulk_action() {
      global $wpdb;
      $table_name = $wpdb->prefix . 'fe_aceptadas';
      if ('delete' === $this->current_action()) {

        $ids = isset($_REQUEST['clave']) ? $_REQUEST['clave'] : array();
        if (is_array($ids))
          $ids = implode(',', $ids);

        if (!empty($ids)) {
          $wpdb->query("DELETE FROM $table_name WHERE clave IN($ids)");
        }
      }
    }

    function prepare_items() {
      global $wpdb;
      $table_name = $wpdb->prefix . 'fe_aceptadas';

      $per_page = 10;

      $columns = $this->get_columns();
      $hidden = array();
      $sortable = $this->get_sortable_columns();

      $this->_column_headers = array($columns, $hidden, $sortable);

      $this->process_bulk_action();

      $total_items = $wpdb->get_var("SELECT COUNT(clave) FROM $table_name");

      $paged = isset($_REQUEST['paged']) ? abs($per_page * ($_REQUEST['paged'] - 1)) : 0;
      $orderby = (isset($_REQUEST['orderby']) && in_array($_REQUEST['orderby'], array_keys($this->get_sortable_columns()))) ? $_REQUEST['orderby'] : 'hacienda_respuesta';
      $order = (isset($_REQUEST['order']) && in_array($_REQUEST['order'], array('asc', 'desc'))) ? $_REQUEST['order'] : 'desc';


      $this->items = $wpdb->get_results($wpdb->prepare("SELECT * FROM $table_name ORDER BY $orderby $order LIMIT %d, %d", $paged, $per_page), ARRAY_A);

      $this->set_pagination_args(array(
        'total_items' => $total_items,
        'per_page' => $per_page,
        'total_pages' => ceil($total_items / $per_page)
      ));
    }

  }

  
endif;