<?php if (!defined('ABSPATH')) exit; // Exit if accessed directly  ?>
<?php
global $post;
$order_id = 0;
if (isset($post->ID) && $post->post_type == 'shop_order') {
  $order_id = $post->ID;
}
elseif (isset($_GET['order_ids'])) {
  $order_id = $_GET['order_ids'];
}
elseif(isset($_GET['order_id'])) {
  $order_id = $_GET['order_id'];
}

$invoice_data = get_post_meta($order_id, '_xml_hacienda', true);
if (is_array($invoice_data)){
  extract($invoice_data); 
}
  

?>
<!DOCTYPE html>
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
    <title><?php echo $this->get_title(); ?></title>
    <style type="text/css"><?php $this->template_styles(); ?></style>
    <style type="text/css"><?php do_action('wpo_wcpdf_custom_styles', $this->get_type(), $this); ?></style>
  </head>
    
  <body class="<?php echo $this->get_type(); ?>">
       
    <div class="row">  
      <div class="column"> 
        <div class="seccion-logo">
          <img src="https://facturaelectronica.outerspacecoders.com/wp-content/plugins/felectronica-server/logos/LOGO400.png" style="display:block;" id="img-header-logo">
        </div> 
      </div>           
    
      <div class="column"> 
    
        <div class="seccion-invoice">   
          <ul>
      
            <li> <?php if($ticket){ ?><li><strong>Tiquete Electrónico</strong><br/> <?php }else if($nota_credito == false ){ ?> <li><strong>Factura Electrónica</strong><br/> <?php } ?> </li>  
            <li> <?php if($nota_credito) { ?> <li><strong>Nota Crédito</strong><br/> <?php } ?></li>  
            <li> Consecutivo N&deg;: 
              <?php
                if(!$nota_credito)
                  echo $consecutivo;
                else
                  echo $nota_credito;
              ?>
            </li>
            <li>Tipo Cambio: <?php echo $tipo_cambio ?></li>
            <li>Condición de venta: <?php if($condicion_venta == '01'){?> <?php echo 'Contado' ?> <?php }?> </li>
            <?php if($condicion_venta == '02'){ ?>
              <li>Plazo de credito: </li>
            <?php } ?>
            <li>Fecha: <?php echo $fecha ?></li>
            <?php if(!$nota_credito) { ?>
              <li>Clave N&deg; <?php echo   $clave   ?> </li></ul>
            <?php } else { ?> 
              <li>Clave N&deg; <?php echo $nc_clave  ?> 
              </li>
            <?php }?>
          </ul>
        </div>         
      </div>
    </div>
          
    <div class="lineas"></div> 
          
    <div class="row">          
      <div class="column">    
        <div class="seccion-emisonr">
          <ul>
            <li><strong>Emisor:  </strong><br/>
            <li>Nombre: <?php echo @$emisor['name']?></li>
            <?php if( @$emisor['id_type'] == '01'){?>
            <li>Cédula física: <?php echo @$emisor['id']?> </li>
            <?php } else  if(@$emisor['id_type'] == '02'){?>
            <li>Cédula Juridica: <?php echo @$emisor['id']?> </li>
            <?php } else if(@$emisor['id_type'] == '03') {?> 
            <li>Cédula Dimex: <?php echo @$emisor['id']?> </li>
            <?php } else if(@$emisor['id_type'] == '04'){?>
            <li>Cédula Nite: <?php echo @$emisor['id']?> </li>
            <?php }?>
            <li>Dirección exacta: <?php echo @$emisor['city']?> ,
            <?php echo @$emisor['address1']?> ,
            <?php echo @$emisor['country']?></li>
            <li>Teléfono: <?php echo @$emisor['phone']?></li>
            <li>Email: <?php echo @$emisor['email']?></li>
          </ul>
        </div>
      </div>
      <?php $comprobantes = ['09','04'];
        if (!in_array($tipo_comprobante, $comprobantes)){ ?>    
          <div class="column">     
            <div class="seccion-receptor">
              <ul>
                <li><strong>Receptor </strong><br/>
                <li>Nombre: <?php echo @$receptor['first_name']?> <?php echo @$receptor['last_name']?> <?php echo @$receptor['name']?></li>
                  <?php if( @$receptor['id_type'] == '01'){?>
                <li>Cédula física: <?php echo @$receptor['id']?> </li>
                <?php } else  if(@$receptor['id_type'] == '02'){?>
                <li>Cédula Juridica: <?php echo @$receptor['id']?> </li>
                <?php } else if(@$receptor['id_type'] == '03') {?> 
                <li>Cédula Dimex: <?php echo @$receptor['id']?> </li>
                <?php } else if(@$receptor['id_type'] == '04'){?>
                <li>Cédula Nite: <?php echo @$receptor['id']?> </li>
                <?php }?>
                <li>Dirección exacta: <?php echo @$receptor['state']?> ,
                <?php echo @$receptor['city']?> ,
                </li>
                <li> <?php echo @$receptor['address1']?></li>
                <li>Teléfono: <?php echo @$receptor['phone']?></li>
                <li>Email: <?php echo @$receptor['email']?></li>
              </ul>
            </div>
          </div>
        <?php }?> 
    </div> 

    <div class="lineas"></div> 
              
    <?php echo $content; ?>         
    <footer>
      <?php if ($order_id) : ?>
        <img id="fe-qr-pdf" src="<?php echo QR_PATH . "{$order_id}.png" ?>" />
      <?php endif ?> 
      <p>"Autorizada mediante resolución N DGT-R-033-2019"</p>
    </footer>
  </body>   
</html>