<?php

/*
  Plugin Name: WC Facturacion Electronica CR PRO
  Plugin URI: https://facturaelectronica.outerspacecoders.com/
  Description: Firma y Envio de xml como factura a hacienda.
  Version: 1.8.3.9
  Author: Outer Space Coders
  Author URI: outerspacecoders.com
  Icon1x: https://facturaelectronica.outerspacecoders.com/wp-content/plugins/felectronica-server/logos/128x128.jpg
  Icon2x: https://facturaelectronica.outerspacecoders.com/wp-content/plugins/felectronica-server/logos/256x256@2x.jpg
  BannerHigh: https://facturaelectronica.outerspacecoders.com/wp-content/plugins/felectronica-server/logos/722x250.jpg
  BannerLow: https://facturaelectronica.outerspacecoders.com/wp-content/plugins/felectronica-server/logos/1544x500.jpg
 */

if (!defined('ABSPATH')) {
  exit; // Exit if accessed directly
}

define('FE_SERVER', 'https://facturaelectronica.outerspacecoders.com');
global $wc_ef_db_version;
$wc_ef_db_version = '1.9';

define('WC_FE_FILE', __FILE__);
require_once plugin_dir_path(__FILE__) . 'lib/wp-package-updater/class-wp-package-updater.php';


/** Enable plugin updates with license check * */
$felectronica_updater = new WP_Package_Updater(
    FE_SERVER, wp_normalize_path(__FILE__), wp_normalize_path(plugin_dir_path(__FILE__)), TRUE
);


function woocommerce_factura_electronica_plugin_run() {
  require_once plugin_dir_path(__FILE__) . 'lib/efactura-client.php';
}

//We create directories to store information when activate the plugin
function woocommerce_factura_electronica_install() {
  if (!(
      wp_mkdir_p(WP_CONTENT_DIR . '/uploads/fefiles/xml/') &&
      wp_mkdir_p(WP_CONTENT_DIR . '/uploads/fefiles/xml_signed/') &&
      wp_mkdir_p(WP_CONTENT_DIR . '/uploads/fefiles/certs/') &&
      wp_mkdir_p(WP_CONTENT_DIR . '/uploads/fefiles/qr/') &&
      wp_mkdir_p(WP_CONTENT_DIR . '/uploads/fefiles/xml_confirm/') &&
      wp_mkdir_p(WP_CONTENT_DIR . '/uploads/fefiles/xml_accept/') &&
      wp_mkdir_p(WP_CONTENT_DIR . '/uploads/fepdf/pdf_report/') &&
      wp_mkdir_p(WP_CONTENT_DIR . '/uploads/fefiles/xml_nota_credito/')
      )) {
    $GLOBALS['wc_efactura']->errormsg('Some directories could not been created, that should be due to a permission issue');
  }

  wc_ef_install();
}
//este metedo permite modificar el campo tipo de cedula de int a varchar ya que el int no interpreta el primer 0 : 01 
function change_fields_ef(){
  global $wpdb;
  global $wc_ef_db_version;
  $table_name = $wpdb->base_prefix . 'fe_aceptadas';
  $sql = "ALTER TABLE {$table_name}
    MODIFY tipo_receptor varchar(2),
    MODIFY tipo_emisor varchar(2)";
  //ejecuta el query
  $wpdb->query($sql);
}
function wc_ef_install() {
  global $wpdb;
  global $wc_ef_db_version;
  $table_name = $wpdb->base_prefix . 'fe_aceptadas';
  $charset_collate = $wpdb->get_charset_collate();
  $sql = "CREATE TABLE {$table_name} (
    clave varchar(50)  NOT NULL PRIMARY KEY,
    cedula_emisor varchar(50)  NOT NULL DEFAULT '',
    cedula_receptor varchar(50)  NOT NULL DEFAULT '',
    fecha varchar(150)  DEFAULT '',
    tipo_emisor smallint(2) NOT NULL,
    tipo_receptor smallint(2) NOT NULL,
    file_name varchar(255)  NOT NULL DEFAULT '',
    hacienda_respuesta varchar(255)  NOT NULL DEFAULT 'SIN FIRMAR' COMMENT 'SIN FIRMAR, FIRMADA, ENVIADA, ACEPTADA, RECHAZADA',
    emisor varchar(150)  NOT NULL DEFAULT '',
    receptor varchar(150)  NOT NULL DEFAULT ''
    ) {$charset_collate};";


  require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
  dbDelta($sql);

  add_site_option('wc_ef_db_version', $wc_ef_db_version);
  //actualiza la version 
  update_site_option('wc_ef_db_version', $wc_ef_db_version);
}

function insert_rates($table_name) {
  $sqlstandar = "INSERT INTO {$table_name} ( `tax_rate_country`, `tax_rate_state`, `tax_rate`, `tax_rate_name`, `tax_rate_priority`, `tax_rate_compound`, `tax_rate_shipping`, `tax_rate_order`, `tax_rate_class`) VALUES
    ('CR', '', '0.0000', 'IVA  0%', 1, 1, 0, 0, 'tarifa-0-exento'),
    ('CR', '', '1.0000', 'IVA  1%', 1, 1, 0, 0, 'tarifa-reducida-1'),
    ('CR', '', '2.0000', 'IVA  2%', 1, 1, 0, 0, 'tarifa-reducida-2'),
    ('CR', '', '4.0000', 'IVA  4%', 1, 1, 0, 0, 'tarifa-reducida-4'),
    ('CR', '', '0.0000', 'IVA  0%,', 1, 1, 0, 0, 'transitorio-0'),
    ('CR', '', '4.0000', 'IVA  4% ', 1, 1, 0, 0, 'transitorio-4'),
    ('CR', '', '8.0000', 'IVA  8% ', 1, 1, 0, 0, 'transitorio-8'),
    ('CR', '', '13.0000','IVA  13%', 1, 1, 0, 0, 'tarifa-general-13'),
    ('CR', '', '0.0000', 'IVA (Calculo especial)  0%', 1, 1, 0, 0, 'iva-calculo-especial-tarifa-0-exento'),
    ('CR', '', '1.0000', 'IVA (Calculo especial)  1%', 1, 1, 0, 0, 'iva-calculo-especial-tarifa-reducida-1'),
    ('CR', '', '2.0000', 'IVA (Calculo especial)  2%', 1, 1, 0, 0, 'iva-calculo-especial-tarifa-reducida-2'),
    ('CR', '', '4.0000', 'IVA (Calculo especial)  4%', 1, 1, 0, 0, 'iva-calculo-especial-tarifa-reducida-4'),
    ('CR', '', '0.0000', 'IVA (Calculo especial)  0%,', 1, 1, 0, 0, 'iva-calculo-especial-transitorio-0'),
    ('CR', '', '4.0000', 'IVA (Calculo especial)  4% ', 1, 1, 0, 0, 'iva-calculo-especial-transitorio-4'),
    ('CR', '', '8.0000', 'IVA (Calculo especial)  8% ', 1, 1, 0, 0, 'iva-calculo-especial-transitorio-8'),
    ('CR', '', '13.0000','IVA (Calculo especial)  13%', 1, 1, 0, 0, 'iva-calculo-especial-tarifa-general-13'),
    ('CR', '', '0.0000', 'IVA Bienes Usados    0%', 1, 1, 0, 0, 'iva-regimen-bienes-usados-tarifa-0-exento'),
    ('CR', '', '1.0000', 'IVA Bienes Usados    1%', 1, 1, 0, 0, 'iva-regimen-bienes-usados-tarifa-reducida-1'),
    ('CR', '', '2.0000', 'IVA Bienes Usados    2%', 1, 1, 0, 0, 'iva-regimen-bienes-usados-tarifa-reducida-2'),
    ('CR', '', '4.0000', 'IVA Bienes Usados    4%', 1, 1, 0, 0, 'iva-regimen-bienes-usados-tarifa-reducida-4'),
    ('CR', '', '0.0000', 'IVA Bienes Usados    0%,', 1, 1, 0, 0, 'iva-regimen-bienes-usados-transitorio-0'),
    ('CR', '', '4.0000', 'IVA Bienes Usados    4% ', 1, 1, 0, 0, 'iva-regimen-bienes-usados-transitorio-4'),
    ('CR', '', '8.0000', 'IVA Bienes Usados    8% ', 1, 1, 0, 0, 'iva-regimen-bienes-usados-transitorio-8'),
    ('CR', '', '13.0000','IVA Bienes Usados   13%', 1, 1, 0, 0, 'iva-regimen-bienes-usados-tarifa-general-13')";
  require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
  dbDelta($sqlstandar);
}

function tax_clases_rates($version) {
  global $wpdb;
  $partes = explode(".", $version);
  $primera_parte = (int) $partes[0];
  $segunda_parte = (int) $partes[1];

  if ($primera_parte >= 3) {
    //se agrega id para evitar duplicidad
    $table_name_classes = $wpdb->base_prefix . 'wc_tax_rate_classes';
    $tipos_impuesto = get_tax_clases_4_3_hacienda();
    //si existe en la base de datos, los elimino y los vuelvo a crear los que yo manejo a nivel de sistema. no va existir problema de duplicidad
    //no puede existir ningun slug igual asi que nunca se duplica.
    
    foreach ($tipos_impuesto as $tax_clases) {
      $sql_insert_tax_clases = "INSERT INTO  {$table_name_classes} ( `name`, `slug`) VALUES ('$tax_clases', '$tax_clases')";
      $wpdb->query($sql_insert_tax_clases);
    }
  }
  else {
    //si de diera el caso que tener una version
    $option_tax = get_option('woocommerce_tax_classes');   // $more_option_to_tax = $option_tax. "Impuesto al valor agregado"."Impuesto Selectivo del consumo";
    //setea los valores que ya existian mas los 8 nuevos impuestos que rigen en la version 4.3
    $options = "" . $option_tax . "\nTarifa 0% (Exento) \n" . "Tarifa reducida 1%  \n" . "Tarifa reducida 2% \n" . "Tarifa reducida 4%\n" . "Transitorio 0%,\n" . "Transitorio 4% \n" . "Transitorio 8%   \n" . "Tarifa general 13%";
    //modifica los valores en la base de datos.
    update_option('woocommerce_tax_classes', $options);
  }
}

function rates_percent() {
  global $wpdb;
  $table_name = $wpdb->base_prefix . 'woocommerce_tax_rates';
  $tipos_impuesto = get_tax_clases_4_3_hacienda();
  foreach ($tipos_impuesto as $tax_clases) {
    $select_tax_rate_class = "select * from $table_name where tax_rate_class in('$tax_clases')";
    $tax_rates[] = $wpdb->get_results($select_tax_rate_class);
  }
  if ($tax_rates == null) {
    insert_rates($table_name);
  }
  else {
    foreach ($tax_rates as $taxes) {
      foreach ($taxes as $tax_class) {
        $delete_tax_tarifas = "delete from $table_name where tax_rate_class in('$tax_class->tax_rate_class')";

        $wpdb->query($delete_tax_tarifas);
      }
    }
    insert_rates($table_name);
  }
}

function wc_ef_update_db_check() {
  global $wc_ef_db_version;
  $db_version = get_site_option('wc_ef_db_version');
  $version = get_option('woocommerce_version');
   if ($db_version != $wc_ef_db_version) {
    /* en esta opcion entra cuando ya exista un db_version en la base de datos, si se cambia no va entrar si se instala por primera vez, por esta comparacion,$db_version != $wc_ef_db_version. hay dos opciones si la version es menor a 7 crea los taxes en los option , 
      sino crear los clases en una tabla pero si ya existen primero los borraria y desde se insertan.
      si cambia de version de woocomercer le migra los option ala base de datos pero igual si existen se borrarán y se crearán desde cero.
     */
    //crea las clases de impuestos o tipos.
    tax_clases_rates($version);
    //crea los porcentajes del iva y borra todos los duclicados.
    rates_percent();
    //llama al metodo para modificar el campo
    change_fields_ef();
    //captura consecutivo anterior 
    //guarda el valor del consecutivo que se manejaba anterioremente en sus facturas:
    if(!($consecutivo_after = get_option('order_consecutive_fe'))){
      $consecutivo_after = get_option('order_consecutive');
      add_option('order_consecutive_fe', $consecutivo_after);   
    }
    //actualizar todos los consecutivos    
    add_option('order_consecutive_ticket', '0000000001');
    add_option('order_consecutive_nota_credito', '0000000001');
    add_option('order_consecutive_mensaje', '0000000001');
    add_option('order_consecutive_exportacion', '0000000001');
    add_option('order_consecutive_compra', '0000000001');
    add_site_option('wc_ef_db_version', $wc_ef_db_version);
    //actualiza la version 
    update_site_option('wc_ef_db_version', $wc_ef_db_version);
  }
  if (!file_exists(WP_CONTENT_DIR . '/uploads/fefiles/xml_accept/')) {
    if (!(wp_mkdir_p(WP_CONTENT_DIR . '/uploads/fefiles/xml_accept/'))) {
      $GLOBALS['wc_efactura']->errormsg('Some directories could not been created, that should be due to a permission issue');
    }
  }
  if (!file_exists(WP_CONTENT_DIR . '/uploads/fepdf/pdf_report/')) {
    if (!(wp_mkdir_p(WP_CONTENT_DIR . '/uploads/fepdf/pdf_report/'))) {
      $GLOBALS['wc_efactura']->errormsg('Some directories could not been created, that should be due to a permission issue');
    }
  }
}

function get_tax_clases_4_3_hacienda() {
  return array(
    'tarifa-0-exento',
    'tarifa-reducida-1',
    'tarifa-reducida-2',
    'tarifa-reducida-4',
    'transitorio-0',
    'transitorio-4',
    'transitorio-8',
    'tarifa-general-13',
    'iva-calculo-especial-tarifa-0-exento',
    'iva-calculo-especial-tarifa-reducida-1',
    'iva-calculo-especial-tarifa-reducida-2',
    'iva-calculo-especial-tarifa-reducida-4',
    'iva-calculo-especial-transitorio-0',
    'iva-calculo-especial-transitorio-4',
    'iva-calculo-especial-transitorio-8',
    'iva-calculo-especial-tarifa-general-13',
    'iva-regimen-bienes-usados-tarifa-0-exento',
    'iva-regimen-bienes-usados-tarifa-reducida-1',
    'iva-regimen-bienes-usados-tarifa-reducida-2',
    'iva-regimen-bienes-usados-tarifa-reducida-4',
    'iva-regimen-bienes-usados-transitorio-0',
    'iva-regimen-bienes-usados-transitorio-4',
    'iva-regimen-bienes-usados-transitorio-8',
    'iva-regimen-bienes-usados-tarifa-general-13',
    'impuesto-selectivo-consumo',
    'impuesto-unico-combustibles',
    'impuesto-especifico-bebidas-alcoholicas',
    'impuesto-especifico-bebidas-sin-alcohol-y-jabones-tocador',
    'impuesto-a-los-productos-de-tabaco',
    'otros'
  );
}

function woocommerce_factura_electronica_get_option($get_name = FALSE) {
  $lics = array(
    'license_key_full-version',
    'license_key_free-version'
  );

  foreach ($lics as $type) {
    if ($license = get_option($type, FALSE)) {
      return $get_name ? $type : $license;
    }
  }
}


/**
 * Display the codigo cabys field
 */
function wc_ef_create_cabys_code_field(){

   $args = array(
   'id' => 'product_cabys_cod_field',
   'label' => __( 'Codigo CAByS', 'wc_ef' ),
   'class' => 'cfwc-codigo-cabys',
   'desc_tip' => true,
   'description' => __( 'Ingrese el nombre del producto del cual desea agregar el codigo. Formato: Nombre_Producto - 0000000000000', 'wc_ef' ),
   );

   woocommerce_wp_text_input( $args );

}

add_action( 'woocommerce_product_options_general_product_data', 'wc_ef_create_cabys_code_field' ); 


/**
 * Save the cabys code field
 * @since 1.0.0
 */
function wc_ef_save_cabys_code_field( $post_id ) {
 $product = wc_get_product( $post_id );
 $value = isset( $_POST['product_cabys_cod_field'] ) ? $_POST['product_cabys_cod_field'] : '';

 $product->update_meta_data( 'product_cabys_cod_field', sanitize_text_field( $value ) );
 $product->save();


}

add_action( 'woocommerce_process_product_meta', 'wc_ef_save_cabys_code_field' );

register_activation_hook(__FILE__, 'woocommerce_factura_electronica_install');
add_action('plugins_loaded', 'woocommerce_factura_electronica_plugin_run', 10, 0);
add_action('plugins_loaded', 'wc_ef_update_db_check');
